/*
 * Copyright (c) 2014 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package de.montiarc.extension.examples.codegen;

import mc.codegen.TemplateCalculator;
import mc.codegen.TemplateOperator;
import mc.umlp.arcd.ets.entries.ComponentEntry;
import mc.umlp.arcd.ets.entries.PortEntry;
import mc.umlp.common._ast.ASTInvariant;

/**
 * TODO: Write me!
 *
 * @author  (last commit) $Author: ahaber $
 * @version $Revision: 3032 $,
 *          $Date: 2014-10-11 18:37:43 +0000 (Sat, 11 Oct 2014) $
 * @since   TODO: add version number
 *
 */
public class InvariantUsesPortCalculator extends TemplateCalculator<ASTInvariant> {
  
  /**
   * @see mc.codegen.TemplateCalculator#calc(mc.ast.ASTNode, mc.codegen.TemplateOperator)
   */
  @Override
  public boolean calc(ASTInvariant ast, TemplateOperator op) {
    
    // has been set by IsSCImplCalculator
    ComponentEntry compEntry = (ComponentEntry) op.getValue("compEntry");
    
    String invContent = ast.printContent();
    
    StringBuilder precondition = new StringBuilder();
    boolean used = false;
    
    precondition.append("(");
    String sep = "";
    for (PortEntry p : compEntry.getAllIncomingPorts(getSymboltable().getModelloader(), getSymboltable().getDeserializers())) {
      if (invContent.contains(p.getName())) {
        precondition.append(sep);
        precondition.append(p.getName());
        precondition.append(" != null");
        sep = " && ";
        used = true;
      }
    }
    precondition.append(")");
    op.setValue("precondition", precondition);
    return used;
  }
  
}
