/*
 * Copyright (c) 2014 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package de.montiarc.extension.examples.syntax.ets;

import mc.ets.serialization.STEntrySerializer.EmbeddedEntry;
import mc.ets.serialization.STEntrySerializer.Serialized;
import mc.umlp.arc.MontiArcConstants;
import mc.umlp.arcd.ets.entries.AComponentImplementationEntry;

/**
 * TODO: Write me!
 *
 * @author  (last commit) $Author: ahaber $
 * @version $Revision: 3031 $,
 *          $Date: 2014-10-10 11:05:58 +0000 (Fri, 10 Oct 2014) $
 * @since   TODO: add version number
 *
 */
public class ArcSCImplementationEntry extends AComponentImplementationEntry {

  public static final String KIND = "ArcSCImplementationEntry";
  
  @Serialized
  @EmbeddedEntry
  private ArcSCEntry sc;
  
  /**
   * Constructor for de.montiarc.extension.examples.syntax.ets.ArcSCImplementationEntry
   */
  public ArcSCImplementationEntry() {
  }
  /**
   * @see interfaces2.STEntry#getLanguage()
   */
  @Override
  public String getLanguage() {
    return MontiArcConstants.MONTI_ARC_LANGUAGE_ID;
  }

  /**
   * @see interfaces2.STEntry#getKind()
   */
  @Override
  public String getKind() {
    return KIND;
  }
  /**
   * @return sc
   */
  public ArcSCEntry getSc() {
    return this.sc;
  }
  /**
   * @param sc the sc to set
   */
  public void setStateChart(ArcSCEntry sc) {
    this.sc = sc;
  }
  
  
  
  
}
