  <#-- ast instanceof ASTSCDefinition --> 
  private enum State {
    <#list ast.getSCStates() as state>
      ${state.printName()},
      <#if state.getSCModifier().isInitial()>
        <#assign initialState = state.printName()>
      </#if>
    </#list>
    ;
    boolean isFinal() {
       <#list ast.getSCStates() as state>
         <#if state.getSCModifier().isFinal()>
           if (this == ${state.printName()}) return true;
         </#if>
       </#list>
       return false;
    }
  }  
    private State currentState = State.${initialState};
    
    private void setState(State toSet) {
      getErrorHandler().getLogger().info(getComponentName() + " switched states: " + currentState + " -> " + toSet);
      currentState = toSet;
    }
    
    protected void triggerSC(${portAndType}) {
       switch(currentState) {
         <#list rtcMap?keys as key>
         case ${key}:
           <#list rtcMap[key] as t>
           <#-- declarations for ocl constraints -->
             <#if t.getSCTransitionBody()?? && t.getSCTransitionBody().getPreCondition()??>
               <#if t.getSCTransitionBody().getPreCondition().getKind()?? &&
                     t.getSCTransitionBody().getPreCondition().getKind() == "OCL">
               ${op.includeTemplates(declaration, t.getSCTransitionBody().getPreCondition().getContent())}
               </#if>
             </#if>
           </#list>
           if (false) {}
           <#list rtcMap[key] as t>   
             <#if t.getSCTransitionBody()?? && t.getSCTransitionBody().printPreCondition() != "">
               else if(${op.includeTemplates(invariantNullCheck, t.getSCTransitionBody().getPreCondition())}) {
             <#else>
               else if (true) {
             </#if> 
             <#if t.getSCTransitionBody()??>
               ${t.getSCTransitionBody().printStatements()}
             </#if>
             setState(State.${t.printTargetName()});
           }
           </#list>
           break;
        </#list>
       }  
    }
    