<#-- Set extension point #-->
${op.setValue("arcElementHook", [
    "de.montiarc.extension.examples.codegen.statechart.SCImpl"])}    

${op.setValue("invariantNullCheck", "de.montiarc.extension.examples.codegen.statechart.InvariantNullCheck")}
${op.setValue("invariant", "mc.umlp.sc.Invariant")}
${op.setValue("declaration", "mc.umlp.ocl.OCLCdDeclaration")}

<#-- Unused hook points                    #-->
<#-- ASTArcComponent passed to:             #-->
${op.setValue("checkConstraintsHook",       [])}
${op.setValue("constructorHook",            [])}
${op.setValue("getLocalTimeHook",           [])}
${op.setValue("handleMessageHook",          [])}
${op.setValue("handleMessageTimeSyncHook",  [])}
${op.setValue("handleTickStartHook",        [])}
${op.setValue("handleTickEndHook",          [])}
${op.setValue("newMethodsHook",             [])}
${op.setValue("setupStartHook",             [])}
${op.setValue("setupEndHook",               [])}
<#-- ASTArcComponent passed to:             #-->
${op.setValue("getPortHook",                [])}
${op.setValue("setPortHook",                [])}
${op.setValue("sendOutPortHook",            [])}
<#-- ASTArcSubComponentInstance passed to:  #-->
${op.setValue("getSubcomponentHook",        [])}
<#-- ASTArcParameter passed to:             #-->
${op.setValue("getConfigParamHook",         [])}

<#-- ${op.setValue("component", "de.montiarc.extension.examples.codegen.comp.Component")} -->
${op.setValue("component", "mc.umlp.arc.component.Component")}

<#-- top level -->
${op.setValue("subcomponentAttributes", "mc.umlp.arc.component.SubcomponentAttributes")}
${op.setValue("ports", [
    "mc.umlp.arc.component.port.PortAttributes", 
    "mc.umlp.arc.component.port.PortAttributesGetter", 
    "mc.umlp.arc.component.port.PortAttributesSetter",
    "mc.umlp.arc.component.port.SimplePortInDelegate",
    "mc.umlp.arc.component.port.PortInDelegate",
    "mc.umlp.arc.component.port.PortOutDelegate",
    "mc.umlp.arc.component.port.TimeSyncMessageBuffer"])}

${op.setValue("timeInPort",             "mc.umlp.arc.component.port.PortTimeIn")}
${op.setValue("timeInPortCalculator",   "mc.umlp.arc.codegen.component.TimeInPortCalculator")}

${op.setValue("head",                   "mc.umlp.arc.component.ConfigurationParameters")}
${op.setValue("methods", [
    "mc.umlp.arc.component.methods.CheckConstraints",
    "mc.umlp.arc.component.methods.Constructor",
    "mc.umlp.arc.component.methods.GetLocalTime",
    "mc.umlp.arc.component.methods.HandleMessage",
    "mc.umlp.arc.component.methods.HandleTimeSyncMessage",
    "mc.umlp.arc.component.methods.HandleTick",
    "mc.umlp.arc.component.methods.Setup", 
    "de.montiarc.extension.examples.codegen.methods.TimeSyncTimeIncreased"])}

${op.setValue("constraint", [
    "mc.umlp.arc.component.methods.CheckConstraint"
])}    

<#-- sub setup method templates -->
${op.setValue("setupArchitecutralPort",         "mc.umlp.arc.component.methods.setup.ArchitecturalPorts")}
${op.setValue("setupArchitecturalSubcomponents","mc.umlp.arc.component.methods.setup.ArchitecturalSubcomponents")}
${op.setValue("setupBehavioralPort",            "mc.umlp.arc.component.methods.setup.AtomicPorts")}
${op.setValue("setupTimeInPort",                "mc.umlp.arc.component.methods.setup.TimeInPort")}
${op.setValue("setupConnectionSetup",           "mc.umlp.arc.component.methods.setup.ConnectionSetup")}
${op.setValue("setupConnectionSuperPortsSetup", "mc.umlp.arc.component.methods.setup.ConnectionSetupSuperPorts")}
${op.setValue("setupConnections",               "mc.umlp.arc.component.methods.setup.Connections")}

${op.setValue("setupEncapsulatePorts",          "mc.umlp.arc.component.methods.setup.EncapsulatePorts")}

<#-- sub sendTick method templates -->
${op.setValue("sendTicksPorts",                 "mc.umlp.arc.component.methods.HandleTickPorts")}

<#-- sub constructor method templates -->
${op.setValue("constructorParameter",           "mc.umlp.arc.component.methods.ConstructorParameters")}

<#-- template calculators -->
${op.setValue("componentCalculator",            "mc.umlp.arc.codegen.component.ComponentCalculator")}
${op.setValue("componentConstructorCalculator", "mc.umlp.arc.codegen.component.methods.ComponentConstructorCalculator")}

<#-- import constants -->
<#if op.callCalculator("mc.umlp.arc.codegen.ConstantsCalculator")>
    ${op.setValue("packagePostfix", PACKAGE_POSTFIX)}
</#if>
<#-- import simulation API class names -->
<#if op.callCalculator("mc.umlp.arc.codegen.SimAPIClassNameCalculator")></#if>

${op.setValue("prefix", "")}
${op.setValue("modifier", "")}

${op.callTemplate(
    component,
    ast.getType().printPackageWithDot()+ packagePostfix + ast.getType().printName(),
    ast.getType())}